<template>
  <!--
    props:
      dataSocial -> the name of the social ['facebook','twitter','linkedin','youtube','instagram','mail']
      dataIsShare -> (bool) set if the button is a share button or a link (the share is only for facebook, linkedin and twitter)
      dataHref -> url for external page
      dataTarget -> (_blank default) set where to open the link
      dataRel-> set the rel
      dataTitleShare ->  title of the share
      dataSubjectMail (only for mail) -> subject of the mail
      dataShareUrl -> url of the share
    -->
  <a
    class="WaSocialShareItem"
    :href="getUrl"
    :target="dataTarget !== '' ? dataTarget : null"
    :rel="dataRel !== '' ? dataRel : null"
    @click="onButtonClick"
  >
    <svg
      width="24"
      height="24"
      :class="['socialIcon', dataSocial ]"
    >
      <use
        :href="`#icon-social-${dataSocial}`"
        fill="currentColor"
      />
    </svg>
    <js-loader
      v-if="dataSocial==='pinterest'"
      :data-async="true"
      :data-defer="true"
      data-id="pinterest-initializer"
      data-src="//assets.pinterest.com/js/pinit.js"
    />
    <!--
      buttonPin if you are using a “one Pin” button, or
      buttonBookmark if you are using an “any Pin” button
  -->
  </a>
</template>
<script>
export default {
  name: "WaSocialShareItem",
  props: {
    dataSocial: {
      type: String,
      default: ''
    },
    dataIsShare: {
      type: [Boolean,String],
      default: false
    },
    dataHref: {
      type: String,
      default: ''
    },
    dataTarget: {
      type: String,
      default: '_blank'
    },
    dataRel: {
      type: String,
      default: ''
    },
    dataTitleShare: {
      type: String,
      default: ''
    },
    dataSubjectMail: {
      type: String,
      default: ''
    },
    dataShareUrl: {
      type: String,
      default: ''
    }
  },
  data() {
    return {}
  },
  computed: {
    twitterShareUrl() {
      return `https://twitter.com/intent/tweet?url=${encodeURI(this.dataShareUrl)}`
    },
    fbShareUrl() {
      return `https://www.facebook.com/sharer/sharer.php?u=${encodeURI(this.dataShareUrl)}`
    },
    linkedinShareUrl() {
      return `https://www.linkedin.com/shareArticle?mini=true&url=${encodeURI(this.dataShareUrl)}&title=${encodeURIComponent(this.dataTitleShare)}&source=LinkedIn`
    },
    mailUrl() {
      return `mailto:?subject=${this.dataTitleShare}&body=${encodeURIComponent(this.dataTitleShare)} ${encodeURI(this.dataShareUrl)}`
    },
    isShare(){
      return this.$_cmsSupport_castPropToType(this.dataIsShare, 'boolean');
    },
    getUrl() {
      if (this.isShare) {
        if (this.dataSocial === 'twitter') {
          return this.twitterShareUrl;
        } else if (this.dataSocial === 'facebook') {
          return this.fbShareUrl;
        } else if (this.dataSocial === 'linkedin') {
          return this.linkedinShareUrl;
        } else if (this.dataSocial === 'mail') {
          return this.mailUrl;
        } else {
          return '#'
        }
      } else {
        return this.dataHref;
      }
    }
  },
  methods: {
    openPopup(event) {
      this.popupCenter(event.currentTarget.href, this.dataTitleShare, 580, 470);
    },
    popupCenter(url, title, w, h) {
      // Fixes dual-screen position                         Most browsers      Firefox
      var dualScreenLeft = window.screenLeft !== undefined ? window.screenLeft : screen.left;
      var dualScreenTop = window.screenTop !== undefined ? window.screenTop : screen.top;

      var width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
      var height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

      var left = ((width / 2) - (w / 2)) + dualScreenLeft;
      var top = ((height / 3) - (h / 3)) + dualScreenTop;

      var newWindow = window.open(url, title, 'scrollbars=yes, width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);

      // Puts focus on the newWindow
      if (newWindow && newWindow.focus) {
        newWindow.focus();
      }
    },
    onButtonClick(event) {
      if (this.isShare && this.dataSocial !== 'mail') {
        event.preventDefault();
        if(this.dataSocial === 'pinterest'){
          window.PinUtils.pinAny();
        }else{
          this.openPopup(event)
        }
      }
    }

  }
};
</script>
<style lang="scss">
@import "~$scss/_variables";

.WaSocialShareItem {
  display: flex;
  width: 45px;
  height: 45px;
  align-items: center;
  justify-content: flex-start;
  color:inherit;
}

.socialIcon {
  display: block;
}

</style>